<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SerializeUtils.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.util</a> &gt; <span class="el_source">SerializeUtils.java</span></div><h1>SerializeUtils.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.util;

import java.io.ByteArrayInputStream;
import java.io.EOFException;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.InputArchive;
import org.apache.jute.OutputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.ZooDefs.OpCode;
import org.apache.zookeeper.server.DataTree;
import org.apache.zookeeper.server.ZooTrace;
import org.apache.zookeeper.txn.CreateSessionTxn;
import org.apache.zookeeper.txn.CreateTxn;
import org.apache.zookeeper.txn.CreateTxnV0;
import org.apache.zookeeper.txn.DeleteTxn;
import org.apache.zookeeper.txn.ErrorTxn;
import org.apache.zookeeper.txn.SetACLTxn;
import org.apache.zookeeper.txn.SetDataTxn;
import org.apache.zookeeper.txn.TxnHeader;
import org.apache.zookeeper.txn.MultiTxn;

<span class="nc" id="L48">public class SerializeUtils {</span>
<span class="fc" id="L49">    private static final Logger LOG = LoggerFactory.getLogger(SerializeUtils.class);</span>
    
    public static Record deserializeTxn(byte txnBytes[], TxnHeader hdr)
            throws IOException {
<span class="fc" id="L53">        final ByteArrayInputStream bais = new ByteArrayInputStream(txnBytes);</span>
<span class="fc" id="L54">        InputArchive ia = BinaryInputArchive.getArchive(bais);</span>

<span class="fc" id="L56">        hdr.deserialize(ia, &quot;hdr&quot;);</span>
<span class="fc" id="L57">        bais.mark(bais.available());</span>
<span class="fc" id="L58">        Record txn = null;</span>
<span class="pc bpc" id="L59" title="1 of 9 branches missed.">        switch (hdr.getType()) {</span>
        case OpCode.createSession:
            // This isn't really an error txn; it just has the same
            // format. The error represents the timeout
<span class="fc" id="L63">            txn = new CreateSessionTxn();</span>
<span class="fc" id="L64">            break;</span>
        case OpCode.closeSession:
<span class="fc" id="L66">            return null;</span>
        case OpCode.create:
<span class="fc" id="L68">            txn = new CreateTxn();</span>
<span class="fc" id="L69">            break;</span>
        case OpCode.delete:
<span class="fc" id="L71">            txn = new DeleteTxn();</span>
<span class="fc" id="L72">            break;</span>
        case OpCode.setData:
<span class="fc" id="L74">            txn = new SetDataTxn();</span>
<span class="fc" id="L75">            break;</span>
        case OpCode.setACL:
<span class="fc" id="L77">            txn = new SetACLTxn();</span>
<span class="fc" id="L78">            break;</span>
        case OpCode.error:
<span class="fc" id="L80">            txn = new ErrorTxn();</span>
<span class="fc" id="L81">            break;</span>
        case OpCode.multi:
<span class="fc" id="L83">            txn = new MultiTxn();</span>
<span class="fc" id="L84">            break;</span>
        default:
<span class="nc" id="L86">            throw new IOException(&quot;Unsupported Txn with type=%d&quot; + hdr.getType());</span>
        }
<span class="pc bpc" id="L88" title="1 of 2 branches missed.">        if (txn != null) {</span>
            try {
<span class="fc" id="L90">                txn.deserialize(ia, &quot;txn&quot;);</span>
<span class="fc" id="L91">            } catch(EOFException e) {</span>
                // perhaps this is a V0 Create
<span class="pc bpc" id="L93" title="1 of 2 branches missed.">                if (hdr.getType() == OpCode.create) {</span>
<span class="fc" id="L94">                    CreateTxn create = (CreateTxn)txn;</span>
<span class="fc" id="L95">                    bais.reset();</span>
<span class="fc" id="L96">                    CreateTxnV0 createv0 = new CreateTxnV0();</span>
<span class="fc" id="L97">                    createv0.deserialize(ia, &quot;txn&quot;);</span>
                    // cool now make it V1. a -1 parentCVersion will
                    // trigger fixup processing in processTxn
<span class="fc" id="L100">                    create.setPath(createv0.getPath());</span>
<span class="fc" id="L101">                    create.setData(createv0.getData());</span>
<span class="fc" id="L102">                    create.setAcl(createv0.getAcl());</span>
<span class="fc" id="L103">                    create.setEphemeral(createv0.getEphemeral());</span>
<span class="fc" id="L104">                    create.setParentCVersion(-1);</span>
<span class="fc" id="L105">                } else {</span>
<span class="nc" id="L106">                    throw e;</span>
                }
<span class="fc" id="L108">            }</span>
        }
<span class="fc" id="L110">        return txn;</span>
    }

    public static void deserializeSnapshot(DataTree dt,InputArchive ia,
            Map&lt;Long, Integer&gt; sessions) throws IOException {
<span class="fc" id="L115">        int count = ia.readInt(&quot;count&quot;);</span>
<span class="fc bfc" id="L116" title="All 2 branches covered.">        while (count &gt; 0) {</span>
<span class="fc" id="L117">            long id = ia.readLong(&quot;id&quot;);</span>
<span class="fc" id="L118">            int to = ia.readInt(&quot;timeout&quot;);</span>
<span class="fc" id="L119">            sessions.put(id, to);</span>
<span class="pc bpc" id="L120" title="1 of 2 branches missed.">            if (LOG.isTraceEnabled()) {</span>
<span class="nc" id="L121">                ZooTrace.logTraceMessage(LOG, ZooTrace.SESSION_TRACE_MASK,</span>
                        &quot;loadData --- session in archive: &quot; + id
                        + &quot; with timeout: &quot; + to);
            }
<span class="fc" id="L125">            count--;</span>
<span class="fc" id="L126">        }</span>
<span class="fc" id="L127">        dt.deserialize(ia, &quot;tree&quot;);</span>
<span class="fc" id="L128">    }</span>

    public static void serializeSnapshot(DataTree dt,OutputArchive oa,
            Map&lt;Long, Integer&gt; sessions) throws IOException {
<span class="fc" id="L132">        HashMap&lt;Long, Integer&gt; sessSnap = new HashMap&lt;Long, Integer&gt;(sessions);</span>
<span class="fc" id="L133">        oa.writeInt(sessSnap.size(), &quot;count&quot;);</span>
<span class="fc bfc" id="L134" title="All 2 branches covered.">        for (Entry&lt;Long, Integer&gt; entry : sessSnap.entrySet()) {</span>
<span class="fc" id="L135">            oa.writeLong(entry.getKey().longValue(), &quot;id&quot;);</span>
<span class="fc" id="L136">            oa.writeInt(entry.getValue().intValue(), &quot;timeout&quot;);</span>
<span class="fc" id="L137">        }</span>
<span class="fc" id="L138">        dt.serialize(oa, &quot;tree&quot;);</span>
<span class="fc" id="L139">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>